servant-client-core-0.20.3.0: Core functionality and class for client function generation for servant APIs

Safe Haskell | None
Language | Haskell2010

Servant.Client.Core.HasClient

Synopsis

- clientIn :: forall (m :: Type -> Type) api. HasClient m api => Proxy api -> Proxy m -> Client m api
- class RunClient m => HasClient (m :: Type -> Type) api where
  - type Client (m :: Type -> Type) api
  - clientWithRoute :: Proxy m -> Proxy api -> Request -> Client m api
  - hoistClientMonad :: Proxy m -> Proxy api -> (forall x. mon x -> mon' x) -> Client mon api -> Client mon' api
- data EmptyClient = EmptyClient
- data AsClientT (m :: Type -> Type)
- (//) :: a -> (a -> b) -> b
- (/:) :: (a -> b -> c) -> b -> a -> c
- foldMapUnion :: forall c a (as :: [Type]). All c as => Proxy c -> (forall x. c x => x -> a) -> Union as -> a
- matchUnion :: forall a (as :: [Type]). IsMember a as => Union as -> Maybe a
- fromSomeClientResponse :: forall a m. (Alternative m, Typeable a) => SomeClientResponse -> m (ResponseF a)

# Documentation

clientIn :: forall (m :: Type -> Type) api. HasClient m api => Proxy api -> Proxy m -> Client m api Source #

`clientIn` allows you to produce operations to query an API from a client within a `RunClient` monad.

    type MyApi = "books" :> Get '[JSON] [Book] -- GET /books
            :<|> "books" :> ReqBody '[JSON] Book :> Post '[JSON] Book -- POST /books

    myApi :: Proxy MyApi
    myApi = Proxy

    clientM :: Proxy ClientM
    clientM = Proxy

    getAllBooks :: ClientM [Book]
    postNewBook :: Book -> ClientM Book
    (getAllBooks :<|> postNewBook) = myApi `clientIn` clientM

class RunClient m => HasClient (m :: Type -> Type) api where Source #

This class lets us define how each API combinator influences the creation of an HTTP request.

Unless you are writing a new backend for `servant-client-core` or new combinators that you want to support client-generation, you can ignore this class.

Associated Types

type Client (m :: Type -> Type) api Source #

Methods

clientWithRoute :: Proxy m -> Proxy api -> Request -> Client m api Source #

hoistClientMonad :: Proxy m -> Proxy api -> (forall x. mon x -> mon' x) -> Client mon api -> Client mon' api Source #

#### Instances

Instances details

RunClient m => HasClient m EmptyAPI Source #

The client for `EmptyAPI` is simply `EmptyClient`.

    type MyAPI = "books" :> Get '[JSON] [Book] -- GET /books
            :<|> "nothing" :> EmptyAPI

    myApi :: Proxy MyApi
    myApi = Proxy

    getAllBooks :: ClientM [Book]
    (getAllBooks :<|> EmptyClient) = client myApi

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m EmptyAPI |
Instance details Defined in Servant.Client.Core.HasClient type Client m EmptyAPI = EmptyClient

Methods

clientWithRoute :: Proxy m -> Proxy EmptyAPI -> Request -> Client m EmptyAPI Source #

hoistClientMonad :: Proxy m -> Proxy EmptyAPI -> (forall x. mon x -> mon' x) -> Client mon EmptyAPI -> Client mon' EmptyAPI Source #

RunClient m => HasClient m Raw Source # | Pick a `Method` and specify where the server you want to query is. You get back the full `Response`.

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m Raw |
Instance details Defined in Servant.Client.Core.HasClient type Client m Raw = Method -> m Response

Methods

clientWithRoute :: Proxy m -> Proxy Raw -> Request -> Client m Raw Source #

hoistClientMonad :: Proxy m -> Proxy Raw -> (forall x. mon x -> mon' x) -> Client mon Raw -> Client mon' Raw Source #

RunClient m => HasClient m RawM Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m RawM |
Instance details Defined in Servant.Client.Core.HasClient type Client m RawM = Method -> m Response

Methods

clientWithRoute :: Proxy m -> Proxy RawM -> Request -> Client m RawM Source #

hoistClientMonad :: Proxy m -> Proxy RawM -> (forall x. mon x -> mon' x) -> Client mon RawM -> Client mon' RawM Source #

(RunClient m, TypeError (NoInstanceFor (HasClient m api)) :: Constraint) => HasClient m api Source # |
Instance details Defined in Servant.Client.Core.HasClient Methods clientWithRoute :: Proxy m -> Proxy api -> Request -> Client m api Source # hoistClientMonad :: Proxy m -> Proxy api -> (forall x. mon x -> mon' x) -> Client mon api -> Client mon' api Source #
(forall (n :: Type -> Type). GClient api n, HasClient m (ToServantApi api), RunClient m, ErrorIfNoGeneric api) => HasClient m (NamedRoutes api) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (NamedRoutes api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (NamedRoutes api) = api (AsClientT m)

Methods

clientWithRoute :: Proxy m -> Proxy (NamedRoutes api) -> Request -> Client m (NamedRoutes api) Source #

hoistClientMonad :: Proxy m -> Proxy (NamedRoutes api) -> (forall x. mon x -> mon' x) -> Client mon (NamedRoutes api) -> Client mon' (NamedRoutes api) Source #

(HasClient m a, HasClient m b) => HasClient m (a :<|> b) Source #

A client querying function for `a `:<|>` b` will actually hand you one function for querying `a` and another one for querying `b`, stitching them together with `:<|>`, which really is just like a pair.

    type MyApi = "books" :> Get '[JSON] [Book] -- GET /books
            :<|> "books" :> ReqBody '[JSON] Book :> Post Book -- POST /books

    myApi :: Proxy MyApi
    myApi = Proxy

    getAllBooks :: ClientM [Book]
    postNewBook :: Book -> ClientM Book
    (getAllBooks :<|> postNewBook) = client myApi

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (a :<|> b) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (a :<|> b) = Client m a :<|> Client m b

Methods

clientWithRoute :: Proxy m -> Proxy (a :<|> b) -> Request -> Client m (a :<|> b) Source #

hoistClientMonad :: Proxy m -> Proxy (a :<|> b) -> (forall x. mon x -> mon' x) -> Client mon (a :<|> b) -> Client mon' (a :<|> b) Source #

(RunClient m, ReflectMethod method) => HasClient m (NoContentVerb method) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (NoContentVerb method) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (NoContentVerb method) = m NoContent

Methods

clientWithRoute :: Proxy m -> Proxy (NoContentVerb method) -> Request -> Client m (NoContentVerb method) Source #

hoistClientMonad :: Proxy m -> Proxy (NoContentVerb method) -> (forall x. mon x -> mon' x) -> Client mon (NoContentVerb method) -> Client mon' (NoContentVerb method) Source #

(RunClient m, TypeError (PartialApplication HasClient arr) :: Constraint) => HasClient m (arr :> sub) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (arr :> sub) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (arr :> sub) = TypeError (PartialApplication HasClient arr) :: Type

Methods

clientWithRoute :: Proxy m -> Proxy (arr :> sub) -> Request -> Client m (arr :> sub) Source #

hoistClientMonad :: Proxy m -> Proxy (arr :> sub) -> (forall x. mon x -> mon' x) -> Client mon (arr :> sub) -> Client mon' (arr :> sub) Source #

(KnownSymbol path, HasClient m api) => HasClient m (path :> api) Source # | Make the querying function append `path` to the request path.

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (path :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (path :> api) = Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (path :> api) -> Request -> Client m (path :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (path :> api) -> (forall x. mon x -> mon' x) -> Client mon (path :> api) -> Client mon' (path :> api) Source #

HasClient m api => HasClient m (HttpVersion :> api) Source # | Using a `HttpVersion` combinator in your API doesn't affect the client functions.

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (HttpVersion :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (HttpVersion :> api) = Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (HttpVersion :> api) -> Request -> Client m (HttpVersion :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (HttpVersion :> api) -> (forall x. mon x -> mon' x) -> Client mon (HttpVersion :> api) -> Client mon' (HttpVersion :> api) Source #

HasClient m api => HasClient m (BasicAuth realm usr :> api) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (BasicAuth realm usr :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (BasicAuth realm usr :> api) = BasicAuthData -> Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (BasicAuth realm usr :> api) -> Request -> Client m (BasicAuth realm usr :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (BasicAuth realm usr :> api) -> (forall x. mon x -> mon' x) -> Client mon (BasicAuth realm usr :> api) -> Client mon' (BasicAuth realm usr :> api) Source #

(ToHttpApiData a, HasClient m api) => HasClient m (Capture' mods capture a :> api) Source #

If you use a `Capture` in one of your endpoints in your API, the corresponding querying function will automatically take an additional argument of the type specified by your `Capture`. That function will take care of inserting a textual representation of this value at the right place in the request path.

You can control how values for this type are turned into text by specifying a `ToHttpApiData` instance for your type.

Example:

    type MyApi = "books" :> Capture "isbn" Text :> Get '[JSON] Book

    myApi :: Proxy MyApi
    myApi = Proxy

    getBook :: Text -> ClientM Book
    getBook = client myApi
    -- then you can just use "getBook" to query that endpoint

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (Capture' mods capture a :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (Capture' mods capture a :> api) = a -> Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (Capture' mods capture a :> api) -> Request -> Client m (Capture' mods capture a :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (Capture' mods capture a :> api) -> (forall x. mon x -> mon' x) -> Client mon (Capture' mods capture a :> api) -> Client mon' (Capture' mods capture a :> api) Source #

(ToHttpApiData a, HasClient m sublayout) => HasClient m (CaptureAll capture a :> sublayout) Source #

If you use a `CaptureAll` in one of your endpoints in your API, the corresponding querying function will automatically take an additional argument of a list of the type specified by your `CaptureAll`. That function will take care of inserting a textual representation of this value at the right place in the request path.

You can control how these values are turned into text by specifying a `ToHttpApiData` instance of your type.

Example:

    type MyAPI = "src" :> CaptureAll Text -> Get '[JSON] SourceFile

    myApi :: Proxy
    myApi = Proxy

    getSourceFile :: [Text] -> ClientM SourceFile
    getSourceFile = client myApi
    -- then you can use "getSourceFile" to query that endpoint

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (CaptureAll capture a :> sublayout) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (CaptureAll capture a :> sublayout) = [a] -> Client m sublayout

Methods

clientWithRoute :: Proxy m -> Proxy (CaptureAll capture a :> sublayout) -> Request -> Client m (CaptureAll capture a :> sublayout) Source #

hoistClientMonad :: Proxy m -> Proxy (CaptureAll capture a :> sublayout) -> (forall x. mon x -> mon' x) -> Client mon (CaptureAll capture a :> sublayout) -> Client mon' (CaptureAll capture a :> sublayout) Source #

HasClient m api => HasClient m (Description desc :> api) Source # | Ignore ``Description`` in client functions.

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (Description desc :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (Description desc :> api) = Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (Description desc :> api) -> Request -> Client m (Description desc :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (Description desc :> api) -> (forall x. mon x -> mon' x) -> Client mon (Description desc :> api) -> Client mon' (Description desc :> api) Source #

HasClient m api => HasClient m (Summary desc :> api) Source # | Ignore ``Summary`` in client functions.

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (Summary desc :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (Summary desc :> api) = Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (Summary desc :> api) -> Request -> Client m (Summary desc :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (Summary desc :> api) -> (forall x. mon x -> mon' x) -> Client mon (Summary desc :> api) -> Client mon' (Summary desc :> api) Source #

HasClient m api => HasClient m (AuthProtect tag :> api) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (AuthProtect tag :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (AuthProtect tag :> api) = AuthenticatedRequest (AuthProtect tag) -> Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (AuthProtect tag :> api) -> Request -> Client m (AuthProtect tag :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (AuthProtect tag :> api) -> (forall x. mon x -> mon' x) -> Client mon (AuthProtect tag :> api) -> Client mon' (AuthProtect tag :> api) Source #

(AtMostOneFragment api, FragmentUnique (Fragment a :> api), HasClient m api) => HasClient m (Fragment a :> api) Source #

Ignore ``Fragment`` in client functions. See https://ietf.org/rfc/rfc2616.html#section-15.1.3 for more details.

Example:

    type MyApi = "books" :> Fragment Text :> Get '[JSON] [Book]

    myApi :: Proxy MyApi
    myApi = Proxy

    getBooks :: ClientM [Book]
    getBooks = client myApi
    -- then you can just use "getBooksBy" to query that endpoint.
    -- 'getBooks' for all books.

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (Fragment a :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (Fragment a :> api) = Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (Fragment a :> api) -> Request -> Client m (Fragment a :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (Fragment a :> api) -> (forall x. mon x -> mon' x) -> Client mon (Fragment a :> api) -> Client mon' (Fragment a :> api) Source #

(KnownSymbol sym, ToHttpApiData a, HasClient m api, SBoolI (FoldRequired mods)) => HasClient m (Header' mods sym a :> api) Source #

If you use a `Header` in one of your endpoints in your API, the corresponding querying function will automatically take an additional argument of the type specified by your `Header`, wrapped in Maybe.

That function will take care of encoding this argument as Text in the request headers.

All you need is for your type to have a `ToHttpApiData` instance.

Example:

    newtype Referer = Referer { referrer :: Text }
      deriving (Eq, Show, Generic, ToHttpApiData)

               -- GET /view-my-referer
    type MyApi = "view-my-referer" :> Header "Referer" Referer :> Get '[JSON] Referer

    myApi :: Proxy MyApi
    myApi = Proxy

    viewReferer :: Maybe Referer -> ClientM Book
    viewReferer = client myApi
    -- then you can just use "viewRefer" to query that endpoint
    -- specifying Nothing or e.g Just "http://haskell.org/" as arguments

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (Header' mods sym a :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (Header' mods sym a :> api) = RequiredArgument mods a -> Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (Header' mods sym a :> api) -> Request -> Client m (Header' mods sym a :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (Header' mods sym a :> api) -> (forall x. mon x -> mon' x) -> Client mon (Header' mods sym a :> api) -> Client mon' (Header' mods sym a :> api) Source #

(KnownSymbol sym, HasClient m api) => HasClient m (Host sym :> api) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (Host sym :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (Host sym :> api) = Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (Host sym :> api) -> Request -> Client m (Host sym :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (Host sym :> api) -> (forall x. mon x -> mon' x) -> Client mon (Host sym :> api) -> Client mon' (Host sym :> api) Source #

HasClient m api => HasClient m (IsSecure :> api) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (IsSecure :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (IsSecure :> api) = Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (IsSecure :> api) -> Request -> Client m (IsSecure :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (IsSecure :> api) -> (forall x. mon x -> mon' x) -> Client mon (IsSecure :> api) -> Client mon' (IsSecure :> api) Source #

(KnownSymbol sym, HasClient m api) => HasClient m (QueryFlag sym :> api) Source #

If you use a `QueryFlag` in one of your endpoints in your API, the corresponding querying function will automatically take an additional `Bool` argument.

If you give `False`, nothing will be added to the query string.

Otherwise, this function will insert a value-less query string parameter under the name associated to your `QueryFlag`.

Example:

    type MyApi = "books" :> QueryFlag "published" :> Get '[JSON] [Book]

    myApi :: Proxy MyApi
    myApi = Proxy

    getBooks :: Bool -> ClientM [Book]
    getBooks = client myApi
    -- then you can just use "getBooks" to query that endpoint.
    -- 'getBooksBy False' for all books
    -- 'getBooksBy True' to only get _already published_ books

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (QueryFlag sym :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (QueryFlag sym :> api) = Bool -> Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (QueryFlag sym :> api) -> Request -> Client m (QueryFlag sym :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (QueryFlag sym :> api) -> (forall x. mon x -> mon' x) -> Client mon (QueryFlag sym :> api) -> Client mon' (QueryFlag sym :> api) Source #

(KnownSymbol sym, ToHttpApiData a, HasClient m api, SBoolI (FoldRequired mods)) => HasClient m (QueryParam' mods sym a :> api) Source #

If you use a `QueryParam` in one of your endpoints in your API, the corresponding querying function will automatically take an additional argument of the type specified by your `QueryParam`, enclosed in Maybe.

If you give Nothing, nothing will be added to the query string.

If you give a non-`Nothing` value, this function will take care of inserting a textual representation of this value in the query string.

You can control how values for your type are turned into text by specifying a `ToHttpApiData` instance for your type.

Example:

    type MyApi = "books" :> QueryParam "author" Text :> Get '[JSON] [Book]

    myApi :: Proxy MyApi
    myApi = Proxy

    getBooksBy :: Maybe Text -> ClientM [Book]
    getBooksBy = client myApi
    -- then you can just use "getBooksBy" to query that endpoint.
    -- 'getBooksBy Nothing' for all books
    -- 'getBooksBy (Just "Isaac Asimov")' to get all books by Isaac Asimov

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (QueryParam' mods sym a :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (QueryParam' mods sym a :> api) = RequiredArgument mods a -> Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (QueryParam' mods sym a :> api) -> Request -> Client m (QueryParam' mods sym a :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (QueryParam' mods sym a :> api) -> (forall x. mon x -> mon' x) -> Client mon (QueryParam' mods sym a :> api) -> Client mon' (QueryParam' mods sym a :> api) Source #

(KnownSymbol sym, ToHttpApiData a, HasClient m api) => HasClient m (QueryParams sym a :> api) Source #

If you use a `QueryParams` in one of your endpoints in your API, the corresponding querying function will automatically take an additional argument, a list of values of the type specified by your `QueryParams`.

If you give an empty list, nothing will be added to the query string.

Otherwise, this function will take care of inserting a textual representation of your values in the query string, under the same query string parameter name.

You can control how values for your type are turned into text by specifying a `ToHttpApiData` instance for your type.

Example:

    type MyApi = "books" :> QueryParams "authors" Text :> Get '[JSON] [Book]

    myApi :: Proxy MyApi
    myApi = Proxy

    getBooksBy :: [Text] -> ClientM [Book]
    getBooksBy = client myApi
    -- then you can just use "getBooksBy" to query that endpoint.
    -- 'getBooksBy []' for all books
    -- 'getBooksBy ["Isaac Asimov", "Robert A. Heinlein"]'
    --   to get all books by Asimov and Heinlein

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (QueryParams sym a :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (QueryParams sym a :> api) = [a] -> Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (QueryParams sym a :> api) -> Request -> Client m (QueryParams sym a :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (QueryParams sym a :> api) -> (forall x. mon x -> mon' x) -> Client mon (QueryParams sym a :> api) -> Client mon' (QueryParams sym a :> api) Source #

(KnownSymbol sym, ToDeepQuery a, HasClient m api) => HasClient m (DeepQuery sym a :> api) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (DeepQuery sym a :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (DeepQuery sym a :> api) = a -> Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (DeepQuery sym a :> api) -> Request -> Client m (DeepQuery sym a :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (DeepQuery sym a :> api) -> (forall x. mon x -> mon' x) -> Client mon (DeepQuery sym a :> api) -> Client mon' (DeepQuery sym a :> api) Source #

HasClient m api => HasClient m (QueryString :> api) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (QueryString :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (QueryString :> api) = Query -> Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (QueryString :> api) -> Request -> Client m (QueryString :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (QueryString :> api) -> (forall x. mon x -> mon' x) -> Client mon (QueryString :> api) -> Client mon' (QueryString :> api) Source #

HasClient m api => HasClient m (RemoteHost :> api) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (RemoteHost :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (RemoteHost :> api) = Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (RemoteHost :> api) -> Request -> Client m (RemoteHost :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (RemoteHost :> api) -> (forall x. mon x -> mon' x) -> Client mon (RemoteHost :> api) -> Client mon' (RemoteHost :> api) Source #

(MimeRender ct a, HasClient m api) => HasClient m (ReqBody' mods (ct ': cts) a :> api) Source #

If you use a `ReqBody` in one of your endpoints in your API, the corresponding querying function will automatically take an additional argument of the type specified by your `ReqBody`. That function will take care of encoding this argument as JSON and of using it as the request body.

All you need is for your type to have a `ToJSON` instance.

Example:

    type MyApi = "books" :> ReqBody '[JSON] Book :> Post '[JSON] Book

    myApi :: Proxy MyApi
    myApi = Proxy

    addBook :: Book -> ClientM Book
    addBook = client myApi
    -- then you can just use "addBook" to query that endpoint

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (ReqBody' mods (ct ': cts) a :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (ReqBody' mods (ct ': cts) a :> api) = a -> Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (ReqBody' mods (ct ': cts) a :> api) -> Request -> Client m (ReqBody' mods (ct ': cts) a :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (ReqBody' mods (ct ': cts) a :> api) -> (forall x. mon x -> mon' x) -> Client mon (ReqBody' mods (ct ': cts) a :> api) -> Client mon' (ReqBody' mods (ct ': cts) a :> api) Source #

(HasClient m api, MimeRender ctype chunk, FramingRender framing, ToSourceIO chunk a) => HasClient m (StreamBody' mods framing ctype a :> api) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (StreamBody' mods framing ctype a :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (StreamBody' mods framing ctype a :> api) = a -> Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (StreamBody' mods framing ctype a :> api) -> Request -> Client m (StreamBody' mods framing ctype a :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (StreamBody' mods framing ctype a :> api) -> (forall x. mon x -> mon' x) -> Client mon (StreamBody' mods framing ctype a :> api) -> Client mon' (StreamBody' mods framing ctype a :> api) Source #

HasClient m subapi => HasClient m (WithResource res :> subapi) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (WithResource res :> subapi) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (WithResource res :> subapi) = Client m subapi

Methods

clientWithRoute :: Proxy m -> Proxy (WithResource res :> subapi) -> Request -> Client m (WithResource res :> subapi) Source #

hoistClientMonad :: Proxy m -> Proxy (WithResource res :> subapi) -> (forall x. mon x -> mon' x) -> Client mon (WithResource res :> subapi) -> Client mon' (WithResource res :> subapi) Source #

HasClient m api => HasClient m (Vault :> api) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (Vault :> api) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (Vault :> api) = Client m api

Methods

clientWithRoute :: Proxy m -> Proxy (Vault :> api) -> Request -> Client m (Vault :> api) Source #

hoistClientMonad :: Proxy m -> Proxy (Vault :> api) -> (forall x. mon x -> mon' x) -> Client mon (Vault :> api) -> Client mon' (Vault :> api) Source #

(RunClient m, TypeError (NoInstanceForSub (HasClient m) ty) :: Constraint) => HasClient m (ty :> sub) Source # |
Instance details Defined in Servant.Client.Core.HasClient Methods clientWithRoute :: Proxy m -> Proxy (ty :> sub) -> Request -> Client m (ty :> sub) Source # hoistClientMonad :: Proxy m -> Proxy (ty :> sub) -> (forall x. mon x -> mon' x) -> Client mon (ty :> sub) -> Client mon' (ty :> sub) Source #
(RunClient m, contentTypes ~ (contentType ': otherContentTypes), as ~ (a ': as'), AllMime contentTypes, ReflectMethod method, All (UnrenderResponse contentTypes) as, All HasStatus as, HasStatuses as', Unique (Statuses as)) => HasClient m (UVerb method contentTypes as) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (UVerb method contentTypes as) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (UVerb method contentTypes as) = m (Union as)

Methods

clientWithRoute :: Proxy m -> Proxy (UVerb method contentTypes as) -> Request -> Client m (UVerb method contentTypes as) Source #

hoistClientMonad :: Proxy m -> Proxy (UVerb method contentTypes as) -> (forall x. mon x -> mon' x) -> Client mon (UVerb method contentTypes as) -> Client mon' (UVerb method contentTypes as) Source #

HasClient m subapi => HasClient m (WithNamedContext name context subapi) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (WithNamedContext name context subapi) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (WithNamedContext name context subapi) = Client m subapi

Methods

clientWithRoute :: Proxy m -> Proxy (WithNamedContext name context subapi) -> Request -> Client m (WithNamedContext name context subapi) Source #

hoistClientMonad :: Proxy m -> Proxy (WithNamedContext name context subapi) -> (forall x. mon x -> mon' x) -> Client mon (WithNamedContext name context subapi) -> Client mon' (WithNamedContext name context subapi) Source #

(ResponseListUnrender cs as, AllMime cs, ReflectMethod method, AsUnion as r, RunClient m) => HasClient m (MultiVerb method cs as r) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (MultiVerb method cs as r) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (MultiVerb method cs as r) = m r

Methods

clientWithRoute :: Proxy m -> Proxy (MultiVerb method cs as r) -> Request -> Client m (MultiVerb method cs as r) Source #

hoistClientMonad :: Proxy m -> Proxy (MultiVerb method cs as r) -> (forall x. mon x -> mon' x) -> Client mon (MultiVerb method cs as r) -> Client mon' (MultiVerb method cs as r) Source #

(RunClient m, HasClient m (SseClientDelegate method status (JsonEventStreamT IO a))) => HasClient m (ServerSentEvents' method status 'JsonEvent a) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (ServerSentEvents' method status 'JsonEvent a) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (ServerSentEvents' method status 'JsonEvent a)

Methods

clientWithRoute :: Proxy m -> Proxy (ServerSentEvents' method status 'JsonEvent a) -> Request -> Client m (ServerSentEvents' method status 'JsonEvent a) Source #

hoistClientMonad :: Proxy m -> Proxy (ServerSentEvents' method status 'JsonEvent a) -> (forall x. mon x -> mon' x) -> Client mon (ServerSentEvents' method status 'JsonEvent a) -> Client mon' (ServerSentEvents' method status 'JsonEvent a) Source #

(RunClient m, HasClient m (SseClientDelegate method status (EventStreamT IO))) => HasClient m (ServerSentEvents' method status 'RawEvent (Event a)) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (ServerSentEvents' method status 'RawEvent (Event a)) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (ServerSentEvents' method status 'RawEvent (Event a))

Methods

clientWithRoute :: Proxy m -> Proxy (ServerSentEvents' method status 'RawEvent (Event a)) -> Request -> Client m (ServerSentEvents' method status 'RawEvent (Event a)) Source #

hoistClientMonad :: Proxy m -> Proxy (ServerSentEvents' method status 'RawEvent (Event a)) -> (forall x. mon x -> mon' x) -> Client mon (ServerSentEvents' method status 'RawEvent (Event a)) -> Client mon' (ServerSentEvents' method status 'RawEvent (Event a)) Source #

(RunClient m, HasClient m (SseClientDelegate method status (EventMessageStreamT IO))) => HasClient m (ServerSentEvents' method status 'RawEvent EventMessage) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (ServerSentEvents' method status 'RawEvent EventMessage) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (ServerSentEvents' method status 'RawEvent EventMessage)

Methods

clientWithRoute :: Proxy m -> Proxy (ServerSentEvents' method status 'RawEvent EventMessage) -> Request -> Client m (ServerSentEvents' method status 'RawEvent EventMessage) Source #

hoistClientMonad :: Proxy m -> Proxy (ServerSentEvents' method status 'RawEvent EventMessage) -> (forall x. mon x -> mon' x) -> Client mon (ServerSentEvents' method status 'RawEvent EventMessage) -> Client mon' (ServerSentEvents' method status 'RawEvent EventMessage) Source #

(RunClient m, ReflectMethod method, KnownNat status) => HasClient m (Verb method status cts NoContent) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (Verb method status cts NoContent) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (Verb method status cts NoContent) = m NoContent
type Client m (Verb method status cts' a) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (Verb method status cts' a) = m a

Methods

clientWithRoute :: Proxy m -> Proxy (Verb method status cts NoContent) -> Request -> Client m (Verb method status cts NoContent) Source #

hoistClientMonad :: Proxy m -> Proxy (Verb method status cts NoContent) -> (forall x. mon x -> mon' x) -> Client mon (Verb method status cts NoContent) -> Client mon' (Verb method status cts NoContent) Source #

(RunClient m, BuildHeadersTo ls, ReflectMethod method, KnownNat status) => HasClient m (Verb method status cts (Headers ls NoContent)) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (Verb method status cts (Headers ls NoContent)) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (Verb method status cts (Headers ls NoContent)) = m (Headers ls NoContent)
type Client m (Verb method status cts' (Headers ls a)) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (Verb method status cts' (Headers ls a)) = m (Headers ls a)
type Client m (Verb method status cts' a) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (Verb method status cts' a) = m a

Methods

clientWithRoute :: Proxy m -> Proxy (Verb method status cts (Headers ls NoContent)) -> Request -> Client m (Verb method status cts (Headers ls NoContent)) Source #

hoistClientMonad :: Proxy m -> Proxy (Verb method status cts (Headers ls NoContent)) -> (forall x. mon x -> mon' x) -> Client mon (Verb method status cts (Headers ls NoContent)) -> Client mon' (Verb method status cts (Headers ls NoContent)) Source #

(RunClient m, MimeUnrender ct a, BuildHeadersTo ls, KnownNat status, ReflectMethod method, cts' ~ (ct ': cts)) => HasClient m (Verb method status cts' (Headers ls a)) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (Verb method status cts' (Headers ls a)) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (Verb method status cts' (Headers ls a)) = m (Headers ls a)
type Client m (Verb method status cts' a) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (Verb method status cts' a) = m a

Methods

clientWithRoute :: Proxy m -> Proxy (Verb method status cts' (Headers ls a)) -> Request -> Client m (Verb method status cts' (Headers ls a)) Source #

hoistClientMonad :: Proxy m -> Proxy (Verb method status cts' (Headers ls a)) -> (forall x. mon x -> mon' x) -> Client mon (Verb method status cts' (Headers ls a)) -> Client mon' (Verb method status cts' (Headers ls a)) Source #

(RunClient m, MimeUnrender ct a, ReflectMethod method, cts' ~ (ct ': cts), KnownNat status) => HasClient m (Verb method status cts' a) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (Verb method status cts' a) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (Verb method status cts' a) = m a

Methods

clientWithRoute :: Proxy m -> Proxy (Verb method status cts' a) -> Request -> Client m (Verb method status cts' a) Source #

hoistClientMonad :: Proxy m -> Proxy (Verb method status cts' a) -> (forall x. mon x -> mon' x) -> Client mon (Verb method status cts' a) -> Client mon' (Verb method status cts' a) Source #

(RunStreamingClient m, MimeUnrender ct chunk, ReflectMethod method, FramingUnrender framing, FromSourceIO chunk a, BuildHeadersTo hs) => HasClient m (Stream method status framing ct (Headers hs a)) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (Stream method status framing ct (Headers hs a)) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (Stream method status framing ct (Headers hs a)) = m (Headers hs a)
type Client m (Stream method status framing ct a) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (Stream method status framing ct a) = m a

Methods

clientWithRoute :: Proxy m -> Proxy (Stream method status framing ct (Headers hs a)) -> Request -> Client m (Stream method status framing ct (Headers hs a)) Source #

hoistClientMonad :: Proxy m -> Proxy (Stream method status framing ct (Headers hs a)) -> (forall x. mon x -> mon' x) -> Client mon (Stream method status framing ct (Headers hs a)) -> Client mon' (Stream method status framing ct (Headers hs a)) Source #

(RunStreamingClient m, MimeUnrender ct chunk, ReflectMethod method, FramingUnrender framing, FromSourceIO chunk a) => HasClient m (Stream method status framing ct a) Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Associated Types

type Client m (Stream method status framing ct a) |
Instance details Defined in Servant.Client.Core.HasClient type Client m (Stream method status framing ct a) = m a

Methods

clientWithRoute :: Proxy m -> Proxy (Stream method status framing ct a) -> Request -> Client m (Stream method status framing ct a) Source #

hoistClientMonad :: Proxy m -> Proxy (Stream method status framing ct a) -> (forall x. mon x -> mon' x) -> Client mon (Stream method status framing ct a) -> Client mon' (Stream method status framing ct a) Source #

data EmptyClient Source #

Singleton type representing a client for an empty API.

Constructors

EmptyClient |

#### Instances

Instances details

Bounded EmptyClient Source # |
Instance details Defined in Servant.Client.Core.HasClient Methods minBound :: EmptyClient Source # maxBound :: EmptyClient Source #
Enum EmptyClient Source # |

Instance details

Defined in Servant.Client.Core.HasClient

Methods

succ :: EmptyClient -> EmptyClient Source #

pred :: EmptyClient -> EmptyClient Source #

toEnum :: Int -> EmptyClient Source #

fromEnum :: EmptyClient -> Int Source #

enumFrom :: EmptyClient -> [EmptyClient] Source #

enumFromThen :: EmptyClient -> EmptyClient -> [EmptyClient] Source #

enumFromTo :: EmptyClient -> EmptyClient -> [EmptyClient] Source #

enumFromThenTo :: EmptyClient -> EmptyClient -> EmptyClient -> [EmptyClient] Source #

Show EmptyClient Source # |
Instance details Defined in Servant.Client.Core.HasClient Methods showsPrec :: Int -> EmptyClient -> ShowS Source # show :: EmptyClient -> String Source # showList :: [EmptyClient] -> ShowS Source #
Eq EmptyClient Source # |
Instance details Defined in Servant.Client.Core.HasClient Methods (==) :: EmptyClient -> EmptyClient -> Bool Source # (/=) :: EmptyClient -> EmptyClient -> Bool Source #

data AsClientT (m :: Type -> Type) Source #

A type that specifies that an API record contains a client implementation.

#### Instances

Instances details

GenericMode (AsClientT m :: Type) Source # |
Instance details Defined in Servant.Client.Core.HasClient
type (AsClientT m :: Type) :- api Source # |
Instance details Defined in Servant.Client.Core.HasClient type (AsClientT m :: Type) :- api = Client m api

(//) :: a -> (a -> b) -> b infixl 1 Source #

Helper to make code using records of clients more readable.

Can be mixed with (/:) for supplying arguments.

Example:

    type Api = NamedRoutes RootApi

    data RootApi mode = RootApi
      { subApi :: mode :- NamedRoutes SubApi
      , …
      } deriving Generic

    data SubApi mode = SubApi
      { endpoint :: mode :- Get '[JSON] Person
      , …
      } deriving Generic

    api :: Proxy API
    api = Proxy

    rootClient :: RootApi (AsClientT ClientM)
    rootClient = client api

    endpointClient :: ClientM Person
    endpointClient = client // subApi // endpoint

(/:) :: (a -> b -> c) -> b -> a -> c infixl 2 Source #

Convenience function for supplying arguments to client functions when working with records of clients.

Intended to be used in conjunction with `(//)`.

Example:

    type Api = NamedRoutes RootApi

    data RootApi mode = RootApi
      { subApi :: mode :- Capture "token" String :> NamedRoutes SubApi
      , hello :: mode :- Capture "name" String :> Get '[JSON] String
      , …
      } deriving Generic

    data SubApi mode = SubApi
      { endpoint :: mode :- Get '[JSON] Person
      , …
      } deriving Generic

    api :: Proxy API
    api = Proxy

    rootClient :: RootApi (AsClientT ClientM)
    rootClient = client api

    hello :: String -> ClientM String
    hello name = rootClient // hello /: name

    endpointClient :: ClientM Person
    endpointClient = client // subApi /: "foobar123" // endpoint

foldMapUnion :: forall c a (as :: [Type]). All c as => Proxy c -> (forall x. c x => x -> a) -> Union as -> a Source #

Convenience function to apply a function to an unknown union element using a type class. All elements of the union must have instances in the type class, and the function is applied unconditionally.

See also: `matchUnion`.

matchUnion :: forall a (as :: [Type]). IsMember a as => Union as -> Maybe a Source #

Convenience function to extract a union element using `cast`, ie. return the value if the selected type happens to be the actual type of the union in this value, or `Nothing` otherwise.

See also: `foldMapUnion`.

fromSomeClientResponse :: forall a m. (Alternative m, Typeable a) => SomeClientResponse -> m (ResponseF a) Source #